#include "waypoint_mfd.h"

double MYMATH::getDist(double b2, double l2)
{
	double l1,b1,r1;
	VESSEL *V = oapiGetFocusInterface();	
	V->GetEquPos(l1,b1,r1);
	VESSELSTATUS vs;
	V->GetStatus(vs);
	OBJHANDLE rb = vs.rbody;
	double a = oapiGetSize(rb);
	double F = (b1+b2)/2;
	double G = (b1-b2)/2;
	double l = (l1-l2)/2;
	double S = (sin(G)*sin(G))*(cos(l)*cos(l)) + (cos(F)*cos(F))*(sin(l)*sin(l));
	double C = (cos(G)*cos(G))*(cos(l)*cos(l)) + (sin(F)*sin(F))*(sin(l)*sin(l));
	double w = atan(sqrt(S/C));
	double R = sqrt(S*C)/w;
	double D = 2*w*a;
	double H1 = (3*R-1)/(2*C);
	double H2 = (3*R+1)/(2*S);
	double f=0;
	double s = D*(1 + f*H1*(sin(F)*sin(F))*(cos(G)*cos(G)) - f*H2*(cos(F)*cos(F))*(sin(G)*sin(G)));
	return s;
}
double MYMATH::getDist(double b1, double l1, double b2, double l2, OBJHANDLE rbody)
{
	OBJHANDLE rb = 0;
	VESSEL *V = oapiGetFocusInterface();	
	VESSELSTATUS vs;
	V->GetStatus(vs);
	if (rbody == 0) rb = vs.rbody;
	else rb = rbody;
	double a = oapiGetSize(rb);
	double F = (b1+b2)/2;
	double G = (b1-b2)/2;
	double l = (l1-l2)/2;
	double S = (sin(G)*sin(G))*(cos(l)*cos(l)) + (cos(F)*cos(F))*(sin(l)*sin(l));
	double C = (cos(G)*cos(G))*(cos(l)*cos(l)) + (sin(F)*sin(F))*(sin(l)*sin(l));
	double w = atan(sqrt(S/C));
	double R = sqrt(S*C)/w;
	double D = 2*w*a;
	double H1 = (3*R-1)/(2*C);
	double H2 = (3*R+1)/(2*S);
	double f=0;
	double s = D*(1 + f*H1*(sin(F)*sin(F))*(cos(G)*cos(G)) - f*H2*(cos(F)*cos(F))*(sin(G)*sin(G)));
	return s;
}
double MYMATH::degToRad(double deg)
{
	return (PI/180)*deg;
}