#include "waypoint_mfd.h"

/*
	ok - Strecke ums Cape
	ok - weiterschalten nur bei turning point
	ok - basen anzeigen
	ok - vtolpads anzeigen
	ok - Aus auswhlbarer Datei einlesen
	ok - hhe fr WP anzeigen
	ok - multivesselfhig
	ok - Listenmodus mit Wegpunktinformationen		
	ok - Description parsen
	ok - Base auswhlbar machen
	ok - speed anzeigen
	ok - Zoom vernnftig mit Anzeige
	ok - "Clear Route" Funktion
	ok - Weiterschaltung nach Takeoff (ber wahre Hhe)

	2: Code vereinfachen
	2: Setting Men (Ein / Ausblenden)... 
	2: VOR's parsen	
	2: Wegmarke Speichern und an datei anhngen
	2: AutoPilot fr Atmosphrenflug mit St DG
	2: flugVektor optional anzeigen?
	2: kml/gpx dateien einlesen

	loopBack => Rcksprung zu definiertem WP
	hhenindikation???
	object statt waypoint auswhlen	
	ObjectWP :-) => Neuer Typ	
	wegpunkttypen wie: VERTICAL_LANDING, VERTICAL_LIFTOFF, HORIZONTAL_LANDING, HORIZONTAL_LIFTOFF, TAXI_POINT, END_POINT
	VOR auswhlbach machen
	VOR als Wegpunkt
	runways parsen?
*/
int curMFD = 0;
vector<MFDHANDLE> gdata;

drawnWaypoint WaypointMFD::createDrawnWaypoint(double x, double y, double radius)
{
	drawnWaypoint wp;
	wp.kind = 0;
	wp.x = int(x);
	wp.y = int(y);
	wp.radius = int(radius);	
	return wp;
}
void WaypointMFD::init()
{
}

void WaypointMFD::drawShipSymbol(oapi::Sketchpad *skp)
{

	skp->SetPen(stdPenX);
	const int symbolSizeShip = 10;
	skp->MoveTo(offsetX, offsetY-symbolSizeShip);
	skp->LineTo(offsetX+symbolSizeShip, offsetY+symbolSizeShip);
	skp->LineTo(offsetX-symbolSizeShip, offsetY+symbolSizeShip);
	skp->LineTo(offsetX, offsetY-symbolSizeShip);
	if (hmfd.route.size() > 0)
	{
		skp->SetPen(darkPenX);
		drawnWaypoint currentWp = equPosToPixelPos(hmfd.route.at(hmfd.selectedWp));		
		skp->Line(offsetX,offsetY, currentWp.x, currentWp.y);	
	}
	oapi::Pen * dashedPen = oapiCreatePen(2,1,darkColor);
	skp->SetPen(dashedPen);
	skp->Line(offsetX,0,offsetX,height);
	skp->Line(0,offsetY,width,offsetY);
	oapiReleasePen(dashedPen);
}

/*
void WaypointMFD::drawMap(oapi::Sketchpad *skp)
{
	skp->SetPen(darkPenX);
	for (int i = 0; i<hmfd.map.size(); i++)
	{
		for (int i2 = 0; i2<hmfd.map.at(i).points.size();i2++)
		{
			drawnWaypoint wp = equPosToPixelPos(hmfd.map.at(i).points.at(i2).lat,hmfd.map.at(i).points.at(i2).lon);
			if (i2 == 0) skp->MoveTo(wp.x,wp.y);
			else 
			{
				if(wp.x>0 && wp.y>0 && wp.x<width && wp.y <height); 
				skp->LineTo(wp.x,wp.y);
			}
		}
	}

}
*/
void WaypointMFD::drawWaypoints(oapi::Sketchpad *skp)
{	
	skp->SetPen(darkPenX);
	for (unsigned int i = 0; i<hmfd.route.size(); i++)
	{
		drawnWaypoint dwp = equPosToPixelPos(hmfd.route.at(i).lat,hmfd.route.at(i).lon,hmfd.route.at(i).radius);				
		//if (hmfd.route.at(i).radius > 0 .type == TURNING_POINT)
		{
			if (hmfd.selectedWp == i)
			{
				skp->SetPen(stdPenX);
				skp->Rectangle(dwp.x-dwp.radius,dwp.y-dwp.radius,dwp.x+dwp.radius,dwp.y+dwp.radius);
			}
			skp->Ellipse(int(dwp.x-dwp.radius),int(dwp.y-dwp.radius),int(dwp.x + dwp.radius),int(dwp.y + dwp.radius));	
		}

		//Connect the line
		if (i > 0)
		{
			skp->SetPen(darkPenX);
			drawnWaypoint pdwp = equPosToPixelPos(hmfd.route.at(i-1).lat,hmfd.route.at(i-1).lon);			
			skp->MoveTo(dwp.x, dwp.y);
			skp->Line(dwp.x, dwp.y,pdwp.x, pdwp.y);
		}
		std::string shownName = hmfd.route.at(i).name;
		if (hmfd.route.at(i).name.compare("") == 0)
		{
			std::stringstream ss;
			ss << i+1;	
			shownName = ss.str();
		}
		else
		{
			shownName = hmfd.route.at(i).name;
		}				
		int fontSize = 20;
		oapi::Font *hf =  oapiCreateFont(20,true,font);
		skp->SetFont(hf);
		skp->SetTextColor(stdColor);
		skp->Text(int(dwp.x-fontSize*.22),int(dwp.y-fontSize*.5),shownName.c_str(),shownName.length());
		oapiReleaseFont(hf);
	}
}
void WaypointMFD::drawBases(oapi::Sketchpad *skp)
{
	
	VESSEL *V = oapiGetFocusInterface();		
	VESSELSTATUS vs;
	V->GetStatus(vs);
	OBJHANDLE rb = vs.rbody;
	double planetSize = oapiGetSize(rb);
	//SelectObject(hDC,darkPen);
	skp->SetPen(darkPenX);
	planetSize = planetSize * hmfd.getZoom(mfdid); 
	planetSize = planetSize*PI;
	//Ellipse (hDC,int(offsetX-planetSize),int(offsetY-planetSize),int(offsetX + planetSize),int(offsetY + planetSize));	
	skp->Ellipse(int(offsetX-planetSize),int(offsetY-planetSize),int(offsetX + planetSize),int(offsetY + planetSize));
	for (unsigned int i=0; i<oapiGetBaseCount(rb); i++)
	{
		OBJHANDLE hbase = oapiGetBaseByIndex(rb,i);		
		double lat,lon,r;
		oapiGetBaseEquPos(hbase,&lon,&lat,&r);
		drawnWaypoint dwp = equPosToPixelPos(lat,lon);
		dwp.radius = 5;
		VESSELSTATUS vs;
		oapiGetFocusInterface()->GetStatus(vs);
		skp->SetPen(darkPenX);
		skp->Rectangle(dwp.x-dwp.radius,dwp.y-dwp.radius,dwp.x+dwp.radius,dwp.y+dwp.radius);
		DWORD colorOld = 0;
		if (hbase == vs.base)
		{
			skp->SetPen(stdPenX);
			colorOld  = skp->SetTextColor(stdColor);
			for (int i = 1; i<5; i++)
				skp->Rectangle(dwp.x-i,dwp.y-i,dwp.x+i,dwp.y+i);
			if (hmfd.route.size() == 0)
			{				
				skp->Line(offsetX,offsetY,dwp.x,dwp.y);
				char basename[255];
				char out0[255];
				char out1[255];						
				oapiGetObjectName(hbase,basename,255);
				sprintf(out0,"BASE: %s" ,basename);
				sprintf(out1,"DIST: %.0f km" ,MYMATH::getDist(lat,lon)/1000);
				string s0(out0);
				string s1(out1);				
				skp->SetTextColor(stdColor);
				skp->SetFont(this->GetDefaultFont(0));
				skp->Text(10,line(2),s0.c_str(),s0.length());
				skp->Text(10,line(3),s1.c_str(),s1.length());
			}
		}
		else
		{
			skp->SetTextColor(darkColor);
		}
		skp->SetPen(darkPenX);
		char  basename[255];		
		oapiGetObjectName(hbase,basename,255);
		std::string shownName(basename);
		int fontSize = 12;
		oapi::Font *hf = oapiCreateFont(fontSize,true,font);
		skp->SetFont(hf);
		skp->Text(dwp.x+10,int(dwp.y-fontSize*.5),shownName.c_str(),shownName.length());
		oapiReleaseFont(hf);
		for (unsigned int i=0; i<oapiGetBasePadCount(hbase); i++)
		{			
			double lat,lon;
			oapiGetBasePadEquPos(hbase,i,&lon,&lat);
			drawnWaypoint dwp = equPosToPixelPos(lat,lon,30);
			skp->Ellipse(int(dwp.x-dwp.radius),int(dwp.y-dwp.radius),int(dwp.x + dwp.radius),int(dwp.y + dwp.radius));
			dwp.radius = int(dwp.radius*.75);
			skp->Ellipse (int(dwp.x-dwp.radius),int(dwp.y-dwp.radius),int(dwp.x + dwp.radius),int(dwp.y + dwp.radius));			
			int fontSize = int(40*hmfd.getZoom(mfdid));
			if (fontSize > 1)
			{
				oapi::Font *hf = oapiCreateFont(fontSize,false,font);
				skp->SetFont(hf);				
				char  basePadId[255];	
				sprintf(basePadId,"%i",i+1);
				std::string shownName(basePadId);
				skp->SetTextColor(stdColor);
				skp->Text(int(dwp.x-fontSize*.22),int(dwp.y-fontSize*.5),shownName.c_str(),shownName.length());
				oapiReleaseFont(hf);
			}
		}
	}
}
void WaypointMFD::drawRunways(oapi::Sketchpad *skp)
{
	//TODO:Paint size of the runway
	skp->SetPen(stdPenX);
	for (unsigned int i = 0; i<hmfd.runways.size();i++)
	{
		point p1 = hmfd.runways.at(i).p1;
		point p2 = hmfd.runways.at(i).p2;
		drawnWaypoint dwp1 = equPosToPixelPos(p1);
		drawnWaypoint dwp2 = equPosToPixelPos(p2);
		skp->Line(dwp1.x,dwp1.y,dwp2.x,dwp2.y);
		//skp->Line(200,200,dwp2.x,dwp2.y);
	}	
}
void WaypointMFD::drawVORs(oapi::Sketchpad *skp)
{
	VESSEL *V = oapiGetFocusInterface();		
	VESSELSTATUS vs;
	V->GetStatus(vs);
	skp->SetPen(stdPenX);
	skp->SetTextColor(stdColor);
	skp->SetFont(this->GetDefaultFont(1));
	for(unsigned int i=0; i<V->GetNavCount();i++)
	{
		NAVHANDLE nh = V->GetNavSource(i);
		if ( nh  != NULL)
		{
			NAVDATA nd;
			oapiGetNavData(nh,&nd);		
			if (nd.type == TRANSMITTER_VOR)
			{
				drawnWaypoint dwp = equPosToPixelPos(nd.vor.lat,nd.vor.lng,oapiGetNavRange(nh));
				dwp.radius = 3;
				skp->Line(dwp.x-dwp.radius,dwp.y,dwp.x+dwp.radius,dwp.y);
				skp->Line(dwp.x,dwp.y-dwp.radius,dwp.x,dwp.y+dwp.radius);
				char  VTORName[255];	
				sprintf(VTORName,"%s",nd.descr);
				std::string shownName(VTORName);
				shownName = "VOR " + shownName;
				oapi::Font *f = oapiCreateFont(12,true,font);
				skp->SetFont(f);
				skp->Text(dwp.x+3,dwp.y,shownName.c_str(),shownName.length());
				oapiReleaseFont(f);
			}
		}		
	}
}
WaypointMFD::WaypointMFD (DWORD w, DWORD h, VESSEL *vessel, unsigned int mfd) : MFD2 (w, h, vessel)
{
	//if (mfd > MAXMFD) mfd = 0;
	parserErrorString = "";
	this->init();
	height = h;
	width = w;
	offsetX = width/2;
	offsetY = height-(height/3);	
	//offsetY = height;
	this->mfdid = mfd;
	getCurrentVesselIndex();
	char myFont[] = "Sans";
	font=myFont;
	
}

//WaypointMFD::~WaypointMFD () {}  //Destructor (not used now)

//This function will be called at any MFD-refresh.
//It can be chanced by Orbiter-launchpad (Parameters->MFD-Refreshrate)

int WaypointMFD::MsgProc (UINT msg, UINT mfinald, WPARAM wparam, LPARAM lparam)
{
	switch (msg) 
	{
		case OAPI_MSG_MFD_OPENEDEX: 
		{
			MFDMODEOPENSPEC *ospec = (MFDMODEOPENSPEC*)wparam;
			return (int)(new WaypointMFD (ospec->w, ospec->h, (VESSEL*)lparam,mfinald));
		}
	}
	return 0;
}
void WaypointMFD::loadTrack()
{
	HANDLE fHandle;
	WIN32_FIND_DATA wfd;

	fHandle=FindFirstFile(".\\Config\\WPMFD\\routes\\*.route",&wfd);
	fileNames.clear();
	hmfd.selectedFile = 0;
	hmfd.maxfiles = 0;
	hmfd.selectedWp = 0;
	do
	{
		if (!( (wfd.cFileName[0]=='.') && ( (wfd.cFileName[1]=='.' && wfd.cFileName[2]==0) || wfd.cFileName[1]==0 ) ))
		{
			if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				//MessageBox(0,wfd.cFileName,"Folgendes Verzeichnis wurde gefunden:",0);
				// Datei ist keine, sondern ein Verzeichnis...
				// Hier knnte man dasselbe nochmal machen, um auch die
				// Unterverzeichnisse zu scannen ;-)
			}
			else
			{
				//MessageBox(0,wfd.cFileName,"Folgende Datei gefunden:",0);
				
				fileNames.push_back(wfd.cFileName);
				hmfd.maxfiles++;
			}
		}
	}
	while (FindNextFile(fHandle,&wfd)!= NULL);
	FindClose(fHandle);
	//hmfd = hmfd;
}

//SURFHANDLE sh = skp->GetSurface();
void WaypointMFD::getCurrentVesselIndex()
{
	VESSEL* vessel = oapiGetFocusInterface();
	OBJHANDLE vh = vessel->GetHandle();
	unsigned int i = 0;
	//bool vesselFound = false;
	for (i; i<gdata.size(); i++)
	{
		if (gdata.at(i).vh == vh)
		{
			for(unsigned int i2 =0;i2<gdata.at(i).smfds.size();i2++)
			{
				if (gdata.at(i).smfds.at(i2).mfdIdentifier == mfdid)
				{
					hmfd = gdata.at(i);
					return;
				}
			}
			SINGLE_MFDSETTINGS mfddat;
			mfddat.mfdIdentifier = mfdid;
			mfddat.mode = 0;			
			mfddat.virtualZoom = 2000;
			mfddat.zoom =  double(this->height) / double(mfddat.virtualZoom);
			gdata.at(i).smfds.push_back(mfddat);
			hmfd = gdata.at(i);
			return;
		}
	}
	MFDHANDLE gd;
	gd.selectedWp = 0;
	gd.style = 0;
	gd.vh = vh;
	gd.vessel = vessel;
	bool mfdIsInit = false;
	for(unsigned int i =0;i<gd.smfds.size();i++)
	{
		if (gd.smfds.at(i).mfdIdentifier == mfdid)
		{
			mfdIsInit = true;
		}
	}
	if (!mfdIsInit)
	{
		SINGLE_MFDSETTINGS mfddat;
		mfddat.mfdIdentifier = mfdid;
		mfddat.mode = 0;
		mfddat.virtualZoom = 2000;
		mfddat.zoom =  double(this->height) / double(mfddat.virtualZoom);
/*
		loadTrack();
		mfddat.mode = 1;
*/
		gd.smfds.push_back(mfddat);
	}
	hmfd = gd;
	gdata.push_back(gd);
}
void WaypointMFD::pushCurrentVesselIndex()
{
	VESSEL* vessel = oapiGetFocusInterface();
	OBJHANDLE vh = vessel->GetHandle();
	unsigned int i = 0;
	for (i; i<gdata.size(); i++)
	{
		if (gdata.at(i).vh == vh)
		{			
			for(unsigned int i2 =0;i2<gdata.at(i).smfds.size();i2++)
			{
				if (gdata.at(i).smfds.at(i2).mfdIdentifier == mfdid)
				{
					gdata.at(i) = hmfd;
					return;
				}
			}
			return; //Error
		}
	}
}
bool WaypointMFD::ConsumeKeyBuffered (DWORD key)
{
	getCurrentVesselIndex();
	unsigned int mode = hmfd.getMode(mfdid);
	double MFDzoom = hmfd.getZoom(mfdid);
	unsigned int virtualZoom = unsigned int(hmfd.getVirtualZoom(mfdid));
	switch(key)
	{
		case OAPI_KEY_C : 			
			if (hmfd.style++>3) hmfd.style = 0;
			
		break;
		case OAPI_KEY_D : 
			hmfd.route.clear();
		break;
	}
	if (mode == 0)
	{
		switch(key)
		{
			case OAPI_KEY_N : 
				if (hmfd.selectedWp+1 < hmfd.route.size()) 
				{
					hmfd.selectedWp++; 
				}			
			break;
			case OAPI_KEY_P : 
				if (int(hmfd.selectedWp) -1 >= 0) 
				{
					hmfd.selectedWp--; 
				}
			break;
			case OAPI_KEY_ADD : 
				if (mode == 0)
					if (virtualZoom /2 >=249 )
						virtualZoom = virtualZoom / 2;
					else virtualZoom = 250;
				break;
			case OAPI_KEY_SUBTRACT : 
				if (mode == 0)
					if (virtualZoom*2 < 131073000.0)
						virtualZoom = virtualZoom * 2;
					else virtualZoom = 131072000;
			break;
			case OAPI_KEY_L : 
				loadTrack();
				mode = 1;	
			break;
			case OAPI_KEY_S : 
				mode = 2;
			break;
		}
	}
	else if (mode == 1)
	{
		switch(key)
		{
			case OAPI_KEY_N : 
				if(hmfd.selectedFile++>=hmfd.maxfiles-1) hmfd.selectedFile=0;
			break;
			case OAPI_KEY_P :
				if (hmfd.selectedFile-- == 0) 
				{
					hmfd.selectedFile = hmfd.maxfiles-1;										
				}
			break;
			case OAPI_KEY_L :
				parseTrack();
				mode = 2;			
			break;
			case OAPI_KEY_S : 
				mode = 2;
			break;
		}
	}
	else if (mode == 2)
	{
		switch(key)
		{
			case OAPI_KEY_S : 
				mode = 0;
			break;
			case OAPI_KEY_N : 
				if (hmfd.selectedWp+1 < hmfd.route.size()) 
				{
					hmfd.selectedWp++; 
				}			
			break;
			case OAPI_KEY_P : 
				if (int(hmfd.selectedWp) -1 >= 0) 
				{
					hmfd.selectedWp--; 
				}
			break;
			case OAPI_KEY_L : 
				loadTrack();
				mode = 1;	
			break;

		}
	}
	MFDzoom = double(this->height) / double(virtualZoom);
	hmfd.setMode(mfdid,mode);
	hmfd.setZoom(mfdid,MFDzoom);
	hmfd.setVirtualZoom(mfdid,virtualZoom);	
	this->InvalidateButtons();
	pushCurrentVesselIndex();
	return false;
}

void WaypointMFD::parseTrack()
{
	parser2 * p = new parser2();	
	hmfd.route.clear();
	if (hmfd.selectedFile < fileNames.size())
	{
		hmfd.route = p->getRoute(".\\Config\\WPMFD\\routes\\" + fileNames.at(hmfd.selectedFile));
		hmfd.runways = p->getRunways();
	}      
	parserErrorString = p->getErrorString();
	delete p;

}
//This function give us the pixel of the Line "i"...
int WaypointMFD::line( int i )
{
   return (int)((float)i*((float)height/20.0));
}

int WaypointMFD::col( int i )
{
   return (int)((float)i*((float)width/20.0));
}

//Here comes the caption for the help-menue of our MFD.
int WaypointMFD::ButtonMenu (const MFDBUTTONMENU **menu) const
{
	unsigned int mode = hmfd.getMode(mfdid);
	//why does hmfd.getMode(mfd) does not work?
	if ( mode == 0)
	{
		static const MFDBUTTONMENU mnu[12] =
		{
			{"Next WP", 0, 'N'},
			{"Prev. WP", 0, 'P'},
			{"Zoom +", 0, 'NUM+'},
			{"Zoom -", 0, 'NUM-'},
			{"Load Track", 0, 'L'},
			{"Switch to List Mode", 0, 'S'},

			{"\0", 0, '\0'},
			{"\0", 0, '\0'},
			{"\0", 0, '\0'},
			{"\0", 0, '\0'},
			{"Clear Route", 0, 'D'},
			{"Toggle Color", 0, '\0'}
		};
		if (menu) *menu = mnu;
		return 12;
	}
	if ( mode == 1)
	{
		static const MFDBUTTONMENU mnu[12] =
		{
			{"Next File", 0, 'N'},
			{"Prev. File", 0, 'P'},
			{"\0", 0, '\0'},
			{"\0", 0, '\0'},
			{"Load Selected File", 0, 'L'},
			{"Switch to List Mode", 0, 'S'},	

			{"\0", 0, '\0'},
			{"\0", 0, '\0'},
			{"\0", 0, '\0'},
			{"\0", 0, '\0'},
			{"Clear Route", 0, 'D'},
			{"Toggle Color", 0, 'C'}
		};
		if (menu) *menu = mnu;
		return 12;
	}
	if ( mode == 2)
	{
		static const MFDBUTTONMENU mnu[12] =
		{
			{"Next WP", 0, 'N'},
			{"Prev. WP", 0, 'P'},
			{"\0", 0, '\0'},
			{"\0", 0, '\0'},
			{"Load Track", 0, 'L'},
			{"Switch to Graphical Mode", 0, 'S'},

			{"\0", 0, '\0'},
			{"\0", 0, '\0'},
			{"\0", 0, '\0'},
			{"\0", 0, '\0'},
			{"Clear Route", 0, 'D'},
			{"Toggle Color", 0, 'C'}
		};
		if (menu) *menu = mnu;
		return 12;
	}
}

//Here comes the caption for the buttons itselfes.
char *WaypointMFD::ButtonLabel (int bt)
{	
	
	//getCurrentVesselIndex();
	unsigned int mode = hmfd.getMode(mfdid);
	if (mode == 0)
	{
		char *label[] = {"PRV","NXT","Z+","Z-","LDT","LST","","", "", "","CRT", "COL"};
		return (bt < 12 ? label[bt] : 0);
	}
	else if (mode == 1)
	{
		char *label[] = {"PRV","NXT","","","LDT","LST","","", "", "","CRT", "COL"};
		return (bt < 12 ? label[bt] : 0);
	}
	else if (mode == 2)
	{
		char *label[] = {"PRV","NXT","","","LDT","GRA","","", "", "","CRT", "COL"};
		return (bt < 12 ? label[bt] : 0);
	}
}

//And here we tell what happend by pressing the button by mouse. At this time (i think always),
//we can simple send back the Keycode of the Keyboardchar.
bool WaypointMFD::ConsumeButton(int bt, int event)
{
   if (event & PANEL_MOUSE_LBDOWN)
   {
      switch( bt )
      {
		  case(0)  : return ConsumeKeyBuffered (OAPI_KEY_P);
		  case(1)  : return ConsumeKeyBuffered (OAPI_KEY_N);
		  case(2)  : return ConsumeKeyBuffered (OAPI_KEY_ADD);
		  case(3)  : return ConsumeKeyBuffered (OAPI_KEY_SUBTRACT);
		  case(4)  : return ConsumeKeyBuffered (OAPI_KEY_L);
		  case(5)  : return ConsumeKeyBuffered (OAPI_KEY_S);
		  case(10)  : return ConsumeKeyBuffered (OAPI_KEY_D);
		  case(11)  : return ConsumeKeyBuffered (OAPI_KEY_C);
		  default  : return false;
      }
   }
   return false;
}

double getDir(double lat2, double lon2)
{
	double tc1 = -1;
	VESSEL *V = oapiGetFocusInterface();
	double _lat1,_lon1,_rad1;
	V->GetEquPos(_lon1,_lat1,_rad1);
	double y = sin(lon2-_lon1)*cos(lat2);
	double x = cos(_lat1)*sin(lat2)-sin(_lat1)*cos(lat2)*cos(lon2-_lon1);
	if (y > 0)
	{
		if (x > 0) tc1 = atan(y/x);
		if (x < 0) tc1 = PI - atan(-y/x);
		if (x == 0) tc1 = PI/2;
	}
	if (y < 0)
	{
		if (x > 0)  tc1 = -atan(-y/x);
		if (x < 0)  tc1 = atan(y/x)-PI;
		if (x == 0) tc1 = PI*1.5;
	}
	if (y == 0)
	{
		if (x > 0) tc1 = 0;
		if (x < 0) tc1 = PI;
		if (x = 0) tc1 = 0;
	}
	double vh = 0;
	oapiGetFocusHeading(&vh);	
	if (tc1 < 0) tc1 = 2*PI + tc1;	
	tc1 = tc1 - vh;	
	if (tc1 < -PI) tc1 = 2*PI + tc1;
	return tc1;
}

std::vector<drawnWaypoint> WaypointMFD::createDrawnRoute() //For test only!
{
	std::vector<drawnWaypoint> meineroute;
	for(unsigned int i = 0; i< hmfd.route.size(); i++)
	{
		
		double dis = MYMATH::getDist(hmfd.route.at(i).lat,hmfd.route.at(i).lon);
		double dir = getDir(hmfd.route.at(i).lat,hmfd.route.at(i).lon);
		double dx = sin(dir)*dis;
		double dy = cos(dir)*dis;
		dx = dx * hmfd.getZoom(mfdid);
		dy = -dy * hmfd.getZoom(mfdid);
		double radiusDrawn = hmfd.route.at(i).radius * hmfd.getZoom(mfdid);
		meineroute.push_back(createDrawnWaypoint(dx,dy,radiusDrawn));		
	}
	return meineroute;
}

drawnWaypoint WaypointMFD::equPosToPixelPos(double lat,double lon, double radius)
{
	double mfdZoom = hmfd.getZoom(mfdid);
	double dis = MYMATH::getDist(lat,lon);
	double dir = getDir(lat,lon);
	drawnWaypoint wp;
	wp.x = int(sin(dir)*dis*mfdZoom+offsetX);
	wp.y = int(-cos(dir)*dis*mfdZoom+offsetY);
	wp.radius = int(radius*mfdZoom);	
	return wp;
}

drawnWaypoint WaypointMFD::equPosToPixelPos(waypoint wp)
{
	return equPosToPixelPos(wp.lat,wp.lon,wp.radius);
}

drawnWaypoint WaypointMFD::equPosToPixelPos(point p)
{
	return equPosToPixelPos(p.lat,p.lon);
}

bool WaypointMFD::Update (oapi::Sketchpad *skp)
{
	getCurrentVesselIndex();
	if (parserErrorString.length() > 1) 
		sprintf(oapiDebugString(),"ERROR PARSING WAYPOINT MFD ROUTE FILE! SEE ORBITER LOG FILE...");
	else 
		sprintf(oapiDebugString(),"");

	const int darkcol = 85;
	const int stdcol = 255;
	unsigned int virtualZoom = hmfd.getVirtualZoom(mfdid);
	double MFDzoom = double(this->height) / double(virtualZoom);
	hmfd.setZoom(mfdid,MFDzoom);
	hmfd.setVirtualZoom(mfdid,virtualZoom);
	switch (hmfd.style)
	{
		case 0: darkColor = RGB(0,darkcol,0); stdColor = RGB(0,stdcol,0); break;//GREEN STYLE
		case 1: darkColor = RGB(darkcol,darkcol,0); stdColor = RGB(stdcol,stdcol,0); break;//YELLOW STYLE
		case 2: darkColor = RGB(0,0,darkcol); stdColor = RGB(0,0,stdcol); break;//BLUE STYLE
		case 3: darkColor = RGB(darkcol,0,0); stdColor = RGB(stdcol,0,0); break;//RED STYLE
		case 4: darkColor = RGB(darkcol,darkcol,darkcol); stdColor = RGB(stdcol,stdcol,stdcol); break;//White STYLE
	}
	darkPenX = oapiCreatePen(1, 1, darkColor);
	stdPenX = oapiCreatePen(1, 1, stdColor);
	skp->SetTextColor(stdColor);
	char outc[255];
	sprintf(outc,"Waypoint MFD               %.2f",virtualZoom/1000.0f);
	string sout(outc);
	skp->Text(5,line(0),sout.c_str(),sout.length());
	switch(hmfd.getMode(mfdid))
	{
		case 0:
			drawWaypoints(skp);
			drawShipSymbol(skp);
			drawBases(skp);
			drawVORs(skp);
			writeWpInfo(skp);
			drawRunways(skp);
			//drawMap(skp);
		break;
		case 1:
			listFiles(skp);
		break;	
		case 2:
			writeWpList(skp);
		break;
	}
	oapiReleasePen(darkPenX);
	oapiReleasePen(stdPenX);
	pushCurrentVesselIndex();
	return true;
}

void WaypointMFD::listFiles(oapi::Sketchpad *skp)
{
	/*
	for(unsigned int i=0; i<fileNames.size(); i++)
	{
		skp->SetTextColor(stdColor);
		if (i != hmfd.selectedFile) 
		{
			skp->SetTextColor(darkColor);
		}
		skp->Text(10,line(i+1),fileNames.at(i).c_str(),fileNames.at(i).size());
	}
	*/
	const int maxLines = 14;
	const int firstLine = 2;

	int i = 0;
	unsigned int routeLength = fileNames.size();
	if (routeLength > maxLines + hmfd.selectedFile) 
		i = hmfd.selectedFile;
	else
		i = routeLength - maxLines;
	if (i<0) i = 0;
	for (i;i<fileNames.size();i++)
	{	
		if (i == hmfd.selectedFile) skp->SetTextColor(stdColor);//SetTextColor(hDC,RGB(0,255,0));
		else skp->SetTextColor(darkColor);//SetTextColor(hDC,RGB(0,55,0));
		int l = i;
		int diff = fileNames.size() - maxLines;
		if (diff > 0)
		{
			if (routeLength > maxLines + hmfd.selectedFile) 
				l = i-hmfd.selectedFile;
			else
				l = i-maxLines+(maxLines-diff);
		}
		skp->Text(10,line(l+firstLine),fileNames.at(i).c_str(),fileNames.at(i).length());
	}
}

void WaypointMFD::writeWpList(oapi::Sketchpad *skp)
{
	const int maxLines = 14;
	int i = 0;
	unsigned int routeLength = hmfd.route.size();
	if (routeLength > maxLines + hmfd.selectedWp) 
		i = hmfd.selectedWp;
	else
		i = routeLength - maxLines;
	if (i<0) i = 0;
	for (i;i<hmfd.route.size();i++)
	{
		//ID
		char buffer[512];
		sprintf(buffer,"%2i",i+1);
		string wpId(buffer);
		//TASK
		switch (hmfd.route.at(i).type)
		{
			case TURNING_POINT:
				sprintf(buffer,"TURN");
			break;
			case LOOPBACK_POINT:
				sprintf(buffer,"LOOP");
			break;
			case TAKEOFF_POINT:
				sprintf(buffer,"TOFF");
			break;
			case LANDING_POINT:
				sprintf(buffer,"LAND");
			break;
		}				
		string wpType(buffer);		
		//SPD
		sprintf(buffer,"%5.0f",hmfd.route.at(i).speed);
		string spd(buffer);		
		//ALT
		sprintf(buffer,"%5.0f",hmfd.route.at(i).alt);
		string alt(buffer);		

		string desText = "";
		if ( hmfd.route.at(i).comment.length() > 0)
			desText = hmfd.route.at(i).comment;
		else
			desText = wpType;
		double distToNxtVal = 0;
		sprintf(buffer,"%4.0f",0);
		if (i +1 < hmfd.route.size())
		{
			double l1,l2,b1,b2;
			l1 = hmfd.route.at(i).lon;
			b1 = hmfd.route.at(i).lat;
			l2 = hmfd.route.at(i+1).lon;
			b2 = hmfd.route.at(i+1).lat;
			distToNxtVal = MYMATH::getDist(b1,l1,b2,l2);
			sprintf(buffer,"%4.0f",distToNxtVal/1000);
		}
		else
		{
			sprintf(buffer,"%4.0f",0.0f);
		}
		string distToNxt(buffer);
		string sout = wpId + " " + spd + " " + alt + " " + distToNxt + " " + desText;
		if (i == hmfd.selectedWp) skp->SetTextColor(stdColor);//SetTextColor(hDC,RGB(0,255,0));
		else skp->SetTextColor(darkColor);//SetTextColor(hDC,RGB(0,55,0));
		int l = i;
		int diff = hmfd.route.size() - maxLines;
		if (diff > 0)
		{
			if (routeLength > maxLines + hmfd.selectedWp) 
				l = i-hmfd.selectedWp;
			else
				l = i-maxLines+(maxLines-diff);
		}
		skp->Text(10,line(l+5),sout.c_str(),sout.length());
	}
	skp->SetTextColor(stdColor);
	string toptext = "|ID | SPD | ALT | DIST NEXT | DESC|"; 
	string units =   "|#  | m/s |  m  |     km    |\\TASK|"; 
	skp->Text(5,line(2),toptext.c_str(),toptext.length());
	skp->Text(5,line(3),units.c_str(),units.length());
}

void WaypointMFD::writeWpInfo(oapi::Sketchpad *skp)
{
	skp->SetTextColor(stdColor);
	if (hmfd.route.size() == 0) return;
	waypoint wp = hmfd.route.at(hmfd.selectedWp);
	double dist = MYMATH::getDist(wp.lat,wp.lon);
	std::string name = hmfd.route.at(hmfd.selectedWp).name;
	char cout1[255]; cout1[0] = '\0';
	char cout2[255]; cout2[0] = '\0';
	char cout3[255]; cout3[0] = '\0';
	char cout4[255]; cout4[0] = '\0';
	char cout5[255]; cout5[0] = '\0';
	char cout6[255]; cout6[0] = '\0';
	if (name.size() == 0)
	{
		sprintf(cout1,"WP: %i",hmfd.selectedWp+1);		
	}
	else
	{
		sprintf(cout1,"WP: %s",name.c_str());
	}
	sprintf(cout2,"DIST: %.0f km",dist/1000);
	switch (hmfd.route.at(hmfd.selectedWp).type)
	{
		case TURNING_POINT:
			sprintf(cout3,"ALT: %.0f m",hmfd.route.at(hmfd.selectedWp).alt); 
			sprintf(cout4,"SPD: %.0f m/s",hmfd.route.at(hmfd.selectedWp).speed); 
			sprintf(cout5,"TASK: TURN"); 
		break;
		case LOOPBACK_POINT:
			sprintf(cout3,"ALT: %.0f m",hmfd.route.at(hmfd.selectedWp).alt); 
			sprintf(cout4,"SPD: %.0f m/s",hmfd.route.at(hmfd.selectedWp).speed);
			sprintf(cout5,"TASK: LOOP"); 
		break;
		case TAKEOFF_POINT:sprintf(cout3,"TASK: TAKEOFF"); break;
		case LANDING_POINT:sprintf(cout3,"TASK: LAND"); break;
	}
	if (hmfd.route.at(hmfd.selectedWp).comment.length() > 0)
	{
		sprintf(cout6,"DESCR: %s",hmfd.route.at(hmfd.selectedWp).comment.c_str()); 
	}
	std::string out1(cout1);
	std::string out2(cout2);
	std::string out3(cout3);
	std::string out4(cout4);
	std::string out5(cout5);
	std::string out6(cout6);
	skp->SetFont(this->GetDefaultFont(0));
	int i = 2;
	skp->Text(10,line(i++),out1.c_str(),out1.length());
	skp->Text(10,line(i++),out2.c_str(),out2.length());
	//if (hmfd.route.at(hmfd.selectedWp).alt > 0)
	skp->Text(10,line(i++),out3.c_str(),out3.length());
	//if (hmfd.route.at(hmfd.selectedWp).speed > 0)
	skp->Text(10,line(i++),out4.c_str(),out4.length());
	skp->Text(10,line(i++),out5.c_str(),out5.length());
	skp->Text(10,line(i++),out6.c_str(),out6.length());
}



/*
http://mathforum.org/library/drmath/view/55417.html
  lon1 = longitude of point A
  lat1 = latitude of point A
  lon2 = longitude of point B
  lat2 = latitude of point B
  tc1 = direction of point B from point A (angle east of north)
  pi = 3.141596...

  dlat = lat2 - lat1
  dlon = lon2 - lon1
  y = sin(lon2-lon1)*cos(lat2)
  x = cos(lat1)*sin(lat2)-sin(lat1)*cos(lat2)*cos(lon2-lon1)
  if y > 0 then
    if x > 0 then tc1 = arctan(y/x)
    if x < 0 then tc1 = 180 - arctan(-y/x)
    if x = 0 then tc1 = 90
  if y < 0 then
    if x > 0 then tc1 = -arctan(-y/x)
    if x < 0 then tc1 = arctan(y/x)-180
    if x = 0 then tc1 = 270
  if y = 0 then
    if x > 0 then tc1 = 0
    if x < 0 then tc1 = 180
    if x = 0 then [the 2 points are the same]
*/